=== debian/changelog ===
rear (2.9+dfsg-3) unstable; urgency=medium

  * [b5665b7] d/control: Adjustment of dependencies 
              after consultation with the upstream developers.

 -- Karsten Schöke <karsten.schoeke@geobasis-bb.de>  Fri, 28 Nov 2025 13:21:56 +0100

rear (2.9+dfsg-2) unstable; urgency=medium

  * [0ddf9f7] d/changelog: fix lintian error
  * [9a1961a] d/watch: switch to v5 format.
  * [9ef50f9] d/control: change Architecture list
              (Closes: #898970)
  * [c8177c4] d/gbp.conf: enable pristine-tar
  * [0b1dba1] insert 0004-systemd-service-file-refers-to-obsolete-bindto.patch
  * [265323e] d/rules: Delete all unnecessary readme files
  * [e60ddb2] update rear.lintian-overrides

 -- Karsten Schöke <karsten.schoeke@geobasis-bb.de>  Mon, 24 Nov 2025 15:33:48 +0100

rear (2.9+dfsg-1) unstable; urgency=medium

  * [19a78c2] New upstream version 2.9
  * [25b31be] insert d/gbp.conf
  * [778c6a8] reogranize patches.
  * [2545d81] insert 0003-Fix-ascidoctor-error.patch
  * [14fdf98] add myself to maintainer, adopt package.
              (Closes: #1117169)
  * [4091f56] d/control: bump standards and drop "Rules-Requires-Root: no"
              default since dpkg 1.22.13
  * [a404afe] remove double man build.
  * [778adb5] update lintian overrides.
  * [bf1fd6c] enable salsa CI gitlab config.
  * [46c11bd] Drop Multi-Arch: same to avoid DEP17 P7
              (multiarch same shared file loss) thx Chris Hofstaedtler
              (Closes: #1056938)
  * [9932cb9] improvement doc build @all
  * [10627eb] Update copyright and add myself
  * [c33e4f8] d/control: remove obsolete util-linux.

 -- Karsten Schöke <karsten.schoeke@geobasis-bb.de>  Tue, 07 Oct 2025 13:19:39 +0200
