=== debian/control ===
Source: rear
Section: admin
Priority: optional
Maintainer: Karsten Schöke <karsten.schoeke@geobasis-bb.de>
Build-Depends: asciidoctor, debhelper-compat (= 13), xmlto
Build-Depends-Indep: source-highlight
Standards-Version: 4.7.2
Homepage: https://relax-and-recover.org/
Vcs-Browser: https://salsa.debian.org/debian/rear
Vcs-Git: https://salsa.debian.org/debian/rear.git

Package: rear-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Bare metal disaster recovery and system migration framework (documentation)
 It is a modular framework with many ready-to-go workflows for common
 situations.  Relax-and-Recover produces a bootable image. This image can
 repartition the system. Once that is done it initiates a restore from backup.
 Restores to different hardware are possible. Relax-and-Recover can therefore be
 used as a migration tool as well.
 .
 This package contains the documentation of rear.

Package: rear
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: attr,
         bc,
         binutils,
         cpio,
         dosfstools,
         e2fsprogs,
         ethtool,
         fdisk,
         file,
         gawk,
         gdisk,
         iproute2,
         iputils-ping,
         isolinux,
         kbd,
         lsb-release,
         net-tools,
         nfs-common,
         openssl,
         parted,
         procps,
         psmisc,
         syslinux[i386 amd64],
         syslinux-common,
         syslinux-efi,
         xorriso,
         ${misc:Depends}
Recommends: nfs-client, portmap, extlinux [amd64 i386]
Description: Bare metal disaster recovery and system migration framework
 It is a modular framework with many ready-to-go workflows for common
 situations.  Relax-and-Recover produces a bootable image. This image can
 repartition the system. Once that is done it initiates a restore from backup.
 Restores to different hardware are possible. Relax-and-Recover can therefore be
 used as a migration tool as well.
