=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -Nrear-doc

execute_after_dh_auto_build:
	$(MAKE) doc

override_dh_install:
	gunzip debian/tmp/usr/share/rear/skel/Debian/default.tar.gz
	gzip -n debian/tmp/usr/share/rear/skel/Debian/default.tar
	rm -fr debian/tmp/usr/share/rear/conf/examples
	find debian/tmp/usr/share/rear -type f -iname "readme" -delete
	dh_install

override_dh_fixperms:
	# Stick to install-config permissions
	dh_fixperms --exclude debian/rear/etc/rear
