=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/rear/rear/git/matching-refs/tags/
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/release/@ANY_VERSION@
Download-Url-Mangle: s%api.github.com/repos/([^/]+/[^/]+)/git/refs/tags/release/@ANY_VERSION@%github.com/$1/archive/refs/tags/release/$2.tar.gz%g
Filename-Mangle: s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Search-Mode: plain
Dversionmangle: s/\+dfsg\d*$//
Repacksuffix: +dfsg
